#!/usr/bin/python

import sys,pywbem,StringIO
#pdb.set_trace()

length = len(sys.argv)
if  length < 4:
  print 'Usage: PciSMX.py HOST NAMESPACE outputfile'
  sys.exit(1)
else:
  host = sys.argv[1]

  namespace = sys.argv[2]

  filename = sys.argv[3]

  pcidev = ['CurrentSpeed','OperationalStatus', 'DesiredSpeed','HealthState']

  cli=pywbem.SFCBUDSConnection('https://%s' % host)
  FILE = open(filename,"w")
  FILE.writelines("<PCIDeviceInstance>")

  provXmloutput = StringIO.StringIO()
  devices = cli.EnumerateInstances('SMX_Fan',namespace)

  for device in devices:
    print >> provXmloutput, '<device '

    pcilen = len(pcidev)
    for index in range(0,pcilen):
      try:
        print >> provXmloutput, ' %s=\"%s\" '  % (pcidev[index], device[pcidev[index]])

      except:
        print "Unknown Error"

    print >> provXmloutput, ' />'

  FILE.writelines(provXmloutput.getvalue())
  provXmloutput.close()

  FILE.writelines("</PCIDeviceInstance>")
  FILE.close()

